(defun my-kill-ring-save ()
  "Like `kill-ring-save', but don't deactivate the mark."
  (interactive)
  (when (called-interactively-p 'any)
    (call-interactively 'kill-ring-save)
    (setq deactivate-mark nil)))

(add-hook 'ielm-mode-hook
          (λ ()
            (eldoc-mode)
            (setq lexical-binding t)
            (setq ielm-dynamic-return nil)
            (local-set-key (kbd "C-j")
                           (λ ()
                             "Call `ielm-return' and indent."
                             (interactive)
                             (ielm-return)
                             (indent-according-to-mode)))
            (local-set-key (kbd "RET")
                           (λ ()
                             (interactive)
                             (push-mark)
                             (goto-char (point-max))
                             (ielm-send-input)))
            (local-set-key (kbd "C-c RET")
                           'elisp-macroexpand-next-sexp)
            (local-set-key (kbd "C-c M-m")
                           (λ ()
                             (interactive)
                             (elisp-macroexpand-next-sexp t)))
            (local-set-key (kbd "M-.")
                           'goto-definition-at-point)
            (local-set-key (kbd "M-*")
                           'pop-goto-definition)))
